from sklearn.neural_network import MLPClassifier
import NNcrossvalidate
import random
import sknn.mlp

#Read data from files into two matrices train and test
#and for labels into trainlabels and testlabels

avgNNerror = 0
data = "breast_cancer_format2/"
for k in range(0, 10, 1):
    f = open(data + "train."+str(k))
    mylist = f.readlines()
    train = []
    for i in range(0,len(mylist),1):
        l = mylist[i].split()
        for j in range(0,len(l),1):
            l[j] = float(l[j])
        train.append(l)
    f.close()

    f = open(data + "test."+str(k))
    mylist = f.readlines()
    test = []
    for i in range(0,len(mylist),1):
        l = mylist[i].split()
        for j in range(0,len(l),1):
            l[j] = float(l[j])
        test.append(l)
    f.close()

    f = open(data + "trainlabels."+str(k))
    mylist = f.readlines()
    trainlabels = []
    n = [0,0]
    for i in range(0,len(mylist),1):
        mylist[i] = float(mylist[i])
        trainlabels.append(mylist[i])
        if(trainlabels[i] == -1):
            trainlabels[i] = 0
        n[int(trainlabels[i])] += 1

    f.close()

    f = open(data + "testlabels."+str(k))
    mylist = f.readlines()
    testlabels = []
    for i in range(0,len(mylist),1):
        mylist[i] = float(mylist[i])
        testlabels.append(mylist[i])
        if(testlabels[i] == -1):
            testlabels[i] = 0
    f.close()

    rows = len(train)
    cols = len(train[0])

## get best value of alpha first
#    best = NNcrossvalidate.getbestalpha(train, trainlabels)
#    print(best)
#    clf = MLPClassifier(alpha=best[0], solver='lbfgs', activation='logistic', hidden_layer_sizes=(100))

    bestseed = 0
    bestloss = 10000000
    for i in range(0, 10, 1):
        r = random.randint(0,10000000)    
        clf = MLPClassifier(solver='lbfgs', activation='logistic', hidden_layer_sizes=(60,10),random_state=r,max_iter=1000)
        clf.fit(train,trainlabels)
        if(clf.loss_ < bestloss):
            bestloss = clf.loss_
            bestseed = r
        print(clf.loss_, bestloss)

    clf = MLPClassifier(solver='lbfgs', activation='logistic', hidden_layer_sizes=(60,10),random_state=bestseed,max_iter=1000)
#    clf = MLPClassifier(solver='lbfgs', activation='logistic', hidden_layer_sizes=(100))
    clf.fit(train,trainlabels)
    prediction = clf.predict(test)
    
#we evaluate our prediction with the test labels
#but we never use the testlabels for the prediction
    err = 0
    for i in range(0, len(prediction), 1):
        if(prediction[i] != testlabels[i]):
            err += 1
    err = err/float(len(testlabels))
    print("NN Test error = ", err)
    avgNNerror += err

avgNNerror /= 10
print("Avg NN errror is ", avgNNerror)

